
package de.ivu.elect.presentation.geodata;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.geodata.boundary.GeodataOrtConversationStore;
import de.ivu.elect.business.geodata.boundary.GeodataOrtExtendedDAO;
import de.ivu.elect.business.geodata.boundary.GeodataOrtEdit;
import de.ivu.elect.business.geodata.entity.GeodataOrt;
import de.ivu.elect.business.geodata.entity.GeodataOrtMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractGeodataOrtEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractGeodataOrtEditNoScopeView.VIEW_ID, useCase = UseCasePermission.GEODATA_ORT_EDIT)
public abstract class AbstractGeodataOrtEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<GeodataOrt>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "geodataOrtEditView";

  public static final String VIEW_ID = "/geodata/geodata-ort-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/geodata/geodata-ort-search.xhtml";

  @Inject
  protected transient GeodataOrtExtendedDAO extendedDAO;

  @Inject
  protected transient GeodataOrtEdit edit;

  @Inject
  @ConversationGroup(GeodataOrtConversationStore.class)
  protected transient GeodataOrtConversationStore conversationStore;

  @Inject
  protected transient GeodataOrtMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient GeodataOrtEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public GeodataOrt getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(GeodataOrt entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GEODATA_ORT_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(GeodataOrt entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.GEODATA_ORT_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.GEODATA_ORT_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GEODATA_ORT_EDIT)
  @Override
  public String save() {
    GeodataOrt entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(GeodataOrt entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    GeodataOrt entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(GeodataOrt entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.GEODATA_ORT_EDIT);
  }
  
  @Redirect
  public String edit(GeodataOrt entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class GeodataOrtEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<GeodataOrt,   de.ivu.elect.business.geodata.entity.GeodataOrtPK  > {

    private static final long serialVersionUID = 1L;
  }
}
